import { LRParser } from '@lezer/lr';
import { LRLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport } from '@codemirror/language';
import { styleTags, tags } from '@lezer/highlight';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "!WQVQPOOOhQPO'#CdOOQO'#Ci'#CiOOQO'#Ce'#CeQVQPOOOOQO,59O,59OOoQPO,59OOOQO-E6c-E6cOOQO1G.j1G.j",
  stateData: "v~O[OS~OQQORQOSQOTQOVPO~OUTO~PVOUWO~PVO",
  goto: "u^PPPPPPPP_ePPPoXQOPSUQSOQUPTVSUXROPSU",
  nodeNames: "⚠ Program CompareOp Keyword String Number ) ( Application",
  maxTerm: 13,
  nodeProps: [
    ["openedBy", 6,"("],
    ["closedBy", 7,")"]
  ],
  skippedNodes: [0],
  repeatNodeCount: 1,
  tokenData: "&n~RfX^!gpq!gqr#[rs#gxy%Tyz%Y{|%_}!O%_!Q!R%h!R![%y!^!_&R!_!`#[!`!a&^!c!}&f#y#z!g$f$g!g#BY#BZ!g$IS$I_!g$I|$JO!g$JT$JU!g$KV$KW!g&FU&FV!g~!lY[~X^!gpq!g#y#z!g$f$g!g#BY#BZ!g$IS$I_!g$I|$JO!g$JT$JU!g$KV$KW!g&FU&FV!g~#_P!_!`#b~#gOQ~~#jVOr#grs$Ps#O#g#O#P$U#P;'S#g;'S;=`$}<%lO#g~$UOS~~$XRO;'S#g;'S;=`$b;=`O#g~$eWOr#grs$Ps#O#g#O#P$U#P;'S#g;'S;=`$};=`<%l#g<%lO#g~%QP;=`<%l#g~%YOV~~%_OU~~%bQ!Q!R%h!R![%y~%mQT~!O!P%s!Q![%y~%vP!Q![%y~&OPT~!Q![%y~&WQQ~!_!`#b!`!a#b~&cPQ~!_!`#b~&kPR~!c!}&f",
  tokenizers: [0],
  topRules: {"Program":[0,1]},
  tokenPrec: 0
});

const NuformulaLanguage = LRLanguage.define({
    parser: parser.configure({
        props: [
            indentNodeProp.add({
                Application: delimitedIndent({ closing: ")", align: false }),
            }),
            foldNodeProp.add({
                Application: foldInside,
            }),
            styleTags({
                Keyword: tags.keyword,
                String: tags.string,
                Number: tags.number,
                CompareOp: tags.compareOperator,
                "( )": tags.paren,
                '"!" ~ "*" + ? |': tags.operator
            }),
        ],
    }),
    languageData: {
        commentTokens: { line: ";" },
    },
});
function nuformula() {
    return new LanguageSupport(NuformulaLanguage);
}

export { NuformulaLanguage, nuformula };
